<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 22/04/2015
 * Time: 17:14
 */

namespace Service\Calendar\Restriction\Strategy;


use Service\Calendar\TaskCalendar;

class DoNotStartAfter extends  RestrictionStrategyAbstract{

    public function getDatesBeginAndEnd($setAllocation = true)
    {
        if($this->task->needScheduleCalcDates()){
            $dateRestriction  = $this->task->getDateException();
            if(!empty($dateRestriction)){
                $dateBegin = clone $this->task->getEstimatedBeginDate();
                $dateEnd = clone $this->task->getEstimatedEndDate();
                if($dateBegin > $dateRestriction){
                    $dateBegin = $dateRestriction;
                }
                $beginPrecursor = $this->getDatesByPrecursor($dateBegin,$dateEnd,$setAllocation);
                if($beginPrecursor < $dateRestriction){
                    $dateBegin = $beginPrecursor;
                }
                $dateEnd = $this->taskCalendar->getDateEnd($this->task,$dateBegin,$setAllocation);
            }else{
                throw new \Exception('Null restriction date');
            }
        }else{
            $dateBegin = $this->task->getEstimatedBeginDate();
            $dateEnd = $this->task->getEstimatedEndDate();
        }
        return array($dateBegin,$dateEnd);
    }

    public function getDatesByPrecursor($beginTask,$endTask,$setAllocation = true)
    {
        if (!$this->task->isContainer()) {
            $datePrecursors = $this->taskCalendar->getDatesPrecursors($this->task, $setAllocation);
            if (!empty($datePrecursors)) {
                foreach ($datePrecursors as $datePrecursor) {
                    list($dateBegin, $dateEnd) = $datePrecursor;
                    if ($dateBegin > $beginTask) {
                        $beginTask = $dateBegin;
                        $endTask = $dateEnd;
                    }
                }
            }
        }
        return $beginTask;
    }

    public function getDatesMinAndMax($dateBeginMax,$dateEndMin)
    {
        if($this->task->usesDataControl()){
            $dateRestriction  = clone $this->task->getDateException();
            if($dateBeginMax > $dateRestriction || is_null($dateBeginMax)){
                $dateBeginMax = $dateRestriction;
            }
        }
        return array($dateBeginMax,$dateEndMin);
    }
}