/*
Tecnisa - Tecnologia em Informtica

Nome: ESTOQRESERVA

Criao:
08/09/2003 - Raphael
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'ESTOQRESERVA'
             AND TYPE   = 'V'
             AND U.UID  = O.UID
             AND U.NAME = USER)

   DROP VIEW ESTOQRESERVA
GO
CREATE VIEW ESTOQRESERVA AS
SELECT
   PE.CDFILIAL,     PE.CDPRODUTO, PE.CDALMOXARIFE, PE.CDLOCALESTOQ,
   PE.NRLOTEESTQ,   PE.NRSUBLOTE, PE.QTTOTALESTOQ, PE.QTTOTRESERVA,
   PE.QTDISPONIVEL, RP.NRPEDIDO,  RP.NRITEMPED,    RP.QTRESPRODPED,
   RP.QTRESPRODARR
FROM
   (SELECT
       ISNULL(PO.CDFILIAL, RE.CDFILIAL) CDFILIAL, ISNULL(PO.CDPRODUTO, RE.CDPRODUTO) CDPRODUTO,
       ISNULL(PO.CDALMOXARIFE, RE.CDALMOXARIFE) CDALMOXARIFE, ISNULL(PO.CDLOCALESTOQ, RE.CDLOCALESTOQ) CDLOCALESTOQ,
       ISNULL(PO.NRLOTEESTQ, RE.NRLOTEESTQ) NRLOTEESTQ, ISNULL(PO.NRSUBLOTE, RE.NRSUBLOTE) NRSUBLOTE,
       PO.QTTOTALESTOQ, RE.QTRESPRODPED QTTOTRESERVA,
       ISNULL(PO.QTTOTALESTOQ, 0) - RE.QTRESPRODARR QTDISPONIVEL
    FROM
       POSESTATU PO LEFT JOIN (SELECT RP.CDFILIAL,   RP.CDPRODUTO , RP.CDALMOXARIFE, RP.CDLOCALESTOQ,
                                      RP.NRLOTEESTQ, RP.NRSUBLOTE, SUM(RP.QTRESPRODARR) QTRESPRODARR,
                                      SUM(RP.QTRESPRODPED) QTRESPRODPED
                               FROM RESERPRODPED RP
                               GROUP BY RP.CDFILIAL, RP.CDPRODUTO, RP.CDALMOXARIFE,
                                        RP.CDLOCALESTOQ, RP.NRLOTEESTQ, RP.NRSUBLOTE) RE ON  PO.CDFILIAL     = RE.CDFILIAL     AND
                                                                                             PO.CDPRODUTO    = RE.CDPRODUTO    AND
                                                                                             PO.CDALMOXARIFE = RE.CDALMOXARIFE AND
                                                                                             PO.CDLOCALESTOQ = RE.CDLOCALESTOQ AND
                                                                                             PO.NRLOTEESTQ   = RE.NRLOTEESTQ   AND
                                                                                             PO.NRSUBLOTE    = RE.NRSUBLOTE
    UNION
    SELECT
       PO.CDFILIAL, PO.CDPRODUTO, PO.CDALMOXARIFE, PO.CDLOCALESTOQ,
       PO.NRLOTEESTQ, PO.NRSUBLOTE, PO.QTTOTALESTOQ, 0 QTTOTRESERVA,
       PO.QTTOTALESTOQ QTDISPONIVEL
    FROM POSESTATU PO
    WHERE
       PO.CDFILIAL+PO.CDPRODUTO+PO.CDALMOXARIFE+
       PO.CDLOCALESTOQ+PO.NRLOTEESTQ+PO.NRSUBLOTE NOT IN
       (SELECT RE.CDFILIAL+RE.CDPRODUTO+RE.CDALMOXARIFE+
               RE.CDLOCALESTOQ+RE.NRLOTEESTQ+RE.NRSUBLOTE
            FROM RESERPRODPED RE
            WHERE PO.CDFILIAL     = RE.CDFILIAL
              AND PO.CDPRODUTO    = RE.CDPRODUTO
              AND PO.CDALMOXARIFE = RE.CDALMOXARIFE
              AND PO.CDLOCALESTOQ = RE.CDLOCALESTOQ
              AND PO.NRLOTEESTQ   = RE.NRLOTEESTQ
              AND PO.NRSUBLOTE    = RE.NRSUBLOTE)) PE LEFT JOIN RESERPRODPED RP ON PE.CDFILIAL     = RP.CDFILIAL     AND
                                                                                   PE.CDPRODUTO    = RP.CDPRODUTO    AND
                                                                                   PE.CDALMOXARIFE = RP.CDALMOXARIFE AND
                                                                                   PE.NRLOTEESTQ   = RP.NRLOTEESTQ   AND
                                                                                   PE.NRSUBLOTE    = RP.NRSUBLOTE
GO

-- VERSAO --
EXEC ATUVEROBJ 'ESTOQRESERVA','4.05.126';
GO

